Index: drivers/filesystems/btrfs/flushthread.c
===================================================================
--- drivers/filesystems/btrfs/flushthread.c	(révision 75772)
+++ drivers/filesystems/btrfs/flushthread.c	(copie de travail)
@@ -5442,110 +7008,156 @@
     ERR("flushed %llu fcbs in %llu (freq = %llu)\n", filerefs, time2.QuadPart - time1.QuadPart, freq.QuadPart);
 #endif
 
-    if (!IsListEmpty(&Vcb->drop_roots)) {
-        Status = drop_roots(Vcb, Irp, rollback);
-        
+    // no need to get dirty_subvols_lock here, as we have tree_lock exclusively
+    while (!IsListEmpty(&Vcb->dirty_subvols)) {
+        root* r = CONTAINING_RECORD(RemoveHeadList(&Vcb->dirty_subvols), root, list_entry_dirty);
+
+        Status = flush_subvol(Vcb, r, Irp);
         if (!NT_SUCCESS(Status)) {
-            ERR("drop_roots returned %08x\n", Status);
+            ERR("flush_subvol returned %08x\n", Status);
             return Status;
         }
     }
-    
-    if (!IsListEmpty(&Vcb->chunks_changed)) {
-        Status = update_chunks(Vcb, &batchlist, Irp, rollback);
-        
+
+    if (!IsListEmpty(&Vcb->drop_roots)) {
+        Status = drop_roots(Vcb, Irp, rollback);
+
         if (!NT_SUCCESS(Status)) {
-            ERR("update_chunks returned %08x\n", Status);
+            ERR("drop_roots returned %08x\n", Status);
             return Status;
         }
     }
-    
-    commit_batch_list(Vcb, &batchlist, Irp, rollback);
-    
+
+    Status = update_chunks(Vcb, &batchlist, Irp, rollback);
+
+    if (!NT_SUCCESS(Status)) {
+        ERR("update_chunks returned %08x\n", Status);
+        return Status;
+    }
+
+    Status = commit_batch_list(Vcb, &batchlist, Irp);
+
     // If only changing superblock, e.g. changing label, we still need to rewrite
     // the root tree so the generations match, otherwise you won't be able to mount on Linux.
     if (!Vcb->root_root->treeholder.tree || !Vcb->root_root->treeholder.tree->write) {
         KEY searchkey;
-        
+
         traverse_ptr tp;
-        
+
         searchkey.obj_id = 0;
         searchkey.obj_type = 0;
         searchkey.offset = 0;
-        
+
         Status = find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("error - find_item returned %08x\n", Status);
             return Status;
         }
-        
+
         Vcb->root_root->treeholder.tree->write = TRUE;
     }
-    
+
     // make sure we always update the extent tree
-    Status = add_root_item_to_cache(Vcb, BTRFS_ROOT_EXTENT, Irp, rollback);
+    Status = add_root_item_to_cache(Vcb, BTRFS_ROOT_EXTENT, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("add_root_item_to_cache returned %08x\n", Status);
         return Status;
     }
-    
+
+    if (Vcb->stats_changed) {
+        le = Vcb->devices.Flink;
+        while (le != &Vcb->devices) {
+            device* dev = CONTAINING_RECORD(le, device, list_entry);
+
+            if (dev->stats_changed) {
+                Status = flush_changed_dev_stats(Vcb, dev, Irp);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("flush_changed_dev_stats returned %08x\n", Status);
+                    return Status;
+                }
+                dev->stats_changed = FALSE;
+            }
+
+            le = le->Flink;
+        }
+
+        Vcb->stats_changed = FALSE;
+    }
+
     do {
-        Status = add_parents(Vcb, Irp, rollback);
+        Status = add_parents(Vcb, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("add_parents returned %08x\n", Status);
             goto end;
         }
-        
-        Status = do_splits(Vcb, Irp, rollback);
+
+        Status = allocate_tree_extents(Vcb, Irp, rollback);
         if (!NT_SUCCESS(Status)) {
-            ERR("do_splits returned %08x\n", Status);
+            ERR("allocate_tree_extents returned %08x\n", Status);
             goto end;
         }
-        
-        Status = allocate_tree_extents(Vcb, Irp, rollback);
+
+        Status = do_splits(Vcb, Irp, rollback);
         if (!NT_SUCCESS(Status)) {
-            ERR("add_parents returned %08x\n", Status);
+            ERR("do_splits returned %08x\n", Status);
             goto end;
         }
-        
+
         Status = update_chunk_usage(Vcb, Irp, rollback);
         if (!NT_SUCCESS(Status)) {
             ERR("update_chunk_usage returned %08x\n", Status);
             goto end;
         }
-        
-        Status = allocate_cache(Vcb, &cache_changed, Irp, rollback);
-        if (!NT_SUCCESS(Status)) {
-            ERR("allocate_cache returned %08x\n", Status);
-            goto end;
+
+        if (!(Vcb->superblock.compat_ro_flags & BTRFS_COMPAT_RO_FLAGS_FREE_SPACE_CACHE)) {
+            if (!no_cache) {
+                Status = allocate_cache(Vcb, &cache_changed, Irp, rollback);
+                if (!NT_SUCCESS(Status)) {
+                    WARN("allocate_cache returned %08x\n", Status);
+                    no_cache = TRUE;
+                    cache_changed = FALSE;
+                }
+            }
+        } else {
+            Status = update_chunk_caches_tree(Vcb, Irp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("update_chunk_caches_tree returned %08x\n", Status);
+                goto end;
+            }
         }
 
 #ifdef DEBUG_WRITE_LOOPS
         loops++;
-        
+
         if (cache_changed)
             ERR("cache has changed, looping again\n");
 #endif
-    } while (cache_changed || !trees_consistent(Vcb, rollback));
-    
+    } while (cache_changed || !trees_consistent(Vcb));
+
 #ifdef DEBUG_WRITE_LOOPS
     ERR("%u loops\n", loops);
 #endif
-    
+
     TRACE("trees consistent\n");
-    
-    Status = update_root_root(Vcb, Irp, rollback);
+
+    Status = update_root_root(Vcb, no_cache, Irp, rollback);
     if (!NT_SUCCESS(Status)) {
         ERR("update_root_root returned %08x\n", Status);
         goto end;
     }
-    
+
     Status = write_trees(Vcb, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("write_trees returned %08x\n", Status);
         goto end;
     }
-    
+
+    Status = test_not_full(Vcb);
+    if (!NT_SUCCESS(Status)) {
+        ERR("test_not_full returned %08x\n", Status);
+        goto end;
+    }
+
 #ifdef DEBUG_PARANOID
     le = Vcb->trees.Flink;
     while (le != &Vcb->trees) {
@@ -5552,78 +7164,129 @@
         tree* t = CONTAINING_RECORD(le, tree, list_entry);
         KEY searchkey;
         traverse_ptr tp;
-        
+
         searchkey.obj_id = t->header.address;
         searchkey.obj_type = TYPE_METADATA_ITEM;
         searchkey.offset = 0xffffffffffffffff;
-        
+
         Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("error - find_item returned %08x\n", Status);
-            int3;
+            goto end;
         }
-        
+
         if (tp.item->key.obj_id != searchkey.obj_id || tp.item->key.obj_type != searchkey.obj_type) {
             searchkey.obj_id = t->header.address;
             searchkey.obj_type = TYPE_EXTENT_ITEM;
             searchkey.offset = 0xffffffffffffffff;
-            
+
             Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
             if (!NT_SUCCESS(Status)) {
                 ERR("error - find_item returned %08x\n", Status);
-                int3;
+                goto end;
             }
-            
+
             if (tp.item->key.obj_id != searchkey.obj_id || tp.item->key.obj_type != searchkey.obj_type) {
                 ERR("error - could not find entry in extent tree for tree at %llx\n", t->header.address);
-                int3;
+                Status = STATUS_INTERNAL_ERROR;
+                goto end;
             }
         }
-        
+
         le = le->Flink;
     }
 #endif
-    
+
     Vcb->superblock.cache_generation = Vcb->superblock.generation;
-    
+
+    if (!Vcb->options.no_barrier)
+        flush_disk_caches(Vcb);
+
     Status = write_superblocks(Vcb, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("write_superblocks returned %08x\n", Status);
         goto end;
     }
-    
+
+    vde = Vcb->vde;
+
+    if (vde) {
+        pdo_device_extension* pdode = vde->pdode;
+
+        ExAcquireResourceSharedLite(&pdode->child_lock, TRUE);
+
+        le = pdode->children.Flink;
+
+        while (le != &pdode->children) {
+            volume_child* vc = CONTAINING_RECORD(le, volume_child, list_entry);
+
+            vc->generation = Vcb->superblock.generation;
+            le = le->Flink;
+        }
+
+        ExReleaseResourceLite(&pdode->child_lock);
+    }
+
     clean_space_cache(Vcb);
-    
+
+    le = Vcb->chunks.Flink;
+    while (le != &Vcb->chunks) {
+        chunk* c = CONTAINING_RECORD(le, chunk, list_entry);
+
+        c->changed = FALSE;
+        c->space_changed = FALSE;
+
+        le = le->Flink;
+    }
+
     Vcb->superblock.generation++;
-    
+
     Status = STATUS_SUCCESS;
-    
+
     le = Vcb->trees.Flink;
     while (le != &Vcb->trees) {
         tree* t = CONTAINING_RECORD(le, tree, list_entry);
 
         t->write = FALSE;
-        
+
         le = le->Flink;
     }
-    
+
     Vcb->need_write = FALSE;
-    
+
     while (!IsListEmpty(&Vcb->drop_roots)) {
-        LIST_ENTRY* le = RemoveHeadList(&Vcb->drop_roots);
-        root* r = CONTAINING_RECORD(le, root, list_entry);
+        root* r = CONTAINING_RECORD(RemoveHeadList(&Vcb->drop_roots), root, list_entry);
 
         ExDeleteResourceLite(&r->nonpaged->load_tree_lock);
         ExFreePool(r->nonpaged);
         ExFreePool(r);
     }
-    
+
 end:
     TRACE("do_write returning %08x\n", Status);
-    
+
     return Status;
 }
 
+NTSTATUS do_write(device_extension* Vcb, PIRP Irp) {
+    LIST_ENTRY rollback;
+    NTSTATUS Status;
+
+    InitializeListHead(&rollback);
+
+    Status = do_write2(Vcb, Irp, &rollback);
+
+    if (!NT_SUCCESS(Status)) {
+        ERR("do_write2 returned %08x, dropping into readonly mode\n", Status);
+        Vcb->readonly = TRUE;
+        FsRtlNotifyVolumeEvent(Vcb->root_file, FSRTL_VOLUME_FORCED_CLOSED);
+        do_rollback(Vcb, &rollback);
+    } else
+        clear_rollback(&rollback);
+
+    return Status;
+}
+
 #ifdef DEBUG_STATS
 static void print_stats(device_extension* Vcb) {
     ERR("READ STATS:\n");
@@ -5633,7 +7296,7 @@
     ERR("csum time taken: %llu\n", Vcb->stats.read_csum_time);
     ERR("disk time taken: %llu\n", Vcb->stats.read_disk_time);
     ERR("other time taken: %llu\n", Vcb->stats.read_total_time - Vcb->stats.read_csum_time - Vcb->stats.read_disk_time);
-    
+
     ERR("OPEN STATS:\n");
     ERR("number of opens: %llu\n", Vcb->stats.num_opens);
     ERR("total time taken: %llu\n", Vcb->stats.open_total_time);
@@ -5640,18 +7303,16 @@
     ERR("number of overwrites: %llu\n", Vcb->stats.num_overwrites);
     ERR("total time taken: %llu\n", Vcb->stats.overwrite_total_time);
     ERR("number of creates: %llu\n", Vcb->stats.num_creates);
+    ERR("calls to open_fcb: %llu\n", Vcb->stats.open_fcb_calls);
+    ERR("time spent in open_fcb: %llu\n", Vcb->stats.open_fcb_time);
     ERR("total time taken: %llu\n", Vcb->stats.create_total_time);
-    
+
     RtlZeroMemory(&Vcb->stats, sizeof(debug_stats));
 }
 #endif
 
 static void do_flush(device_extension* Vcb) {
-    LIST_ENTRY rollback;
-    
-    InitializeListHead(&rollback);
-    
-    FsRtlEnterFileSystem();
+    NTSTATUS Status;
 
     ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
 
@@ -5660,46 +7321,52 @@
 #endif
 
     if (Vcb->need_write && !Vcb->readonly)
-        do_write(Vcb, NULL, &rollback);
-    
+        Status = do_write(Vcb, NULL);
+    else
+        Status = STATUS_SUCCESS;
+
     free_trees(Vcb);
-    
-    clear_rollback(Vcb, &rollback);
 
+    if (!NT_SUCCESS(Status))
+        ERR("do_write returned %08x\n", Status);
+
     ExReleaseResourceLite(&Vcb->tree_lock);
-
-    FsRtlExitFileSystem();
 }
 
-void STDCALL flush_thread(void* context) {
+_Function_class_(KSTART_ROUTINE)
+#ifdef __REACTOS__
+void NTAPI flush_thread(void* context) {
+#else
+void flush_thread(void* context) {
+#endif
     DEVICE_OBJECT* devobj = context;
     device_extension* Vcb = devobj->DeviceExtension;
     LARGE_INTEGER due_time;
-    
+
     ObReferenceObject(devobj);
-    
+
     KeInitializeTimer(&Vcb->flush_thread_timer);
-    
+
     due_time.QuadPart = (UINT64)Vcb->options.flush_interval * -10000000;
-    
+
     KeSetTimer(&Vcb->flush_thread_timer, due_time, NULL);
-    
+
     while (TRUE) {
         KeWaitForSingleObject(&Vcb->flush_thread_timer, Executive, KernelMode, FALSE, NULL);
 
         if (!(devobj->Vpb->Flags & VPB_MOUNTED) || Vcb->removing)
             break;
-        
+
         if (!Vcb->locked)
             do_flush(Vcb);
-        
+
         KeSetTimer(&Vcb->flush_thread_timer, due_time, NULL);
     }
-    
+
     ObDereferenceObject(devobj);
     KeCancelTimer(&Vcb->flush_thread_timer);
-    
+
     KeSetEvent(&Vcb->flush_thread_finished, 0, FALSE);
-    
+
     PsTerminateSystemThread(STATUS_SUCCESS);
 }
